# IRAF script -- _ddispsize.cl
#
#   this is a hidden subtask of CIRDITHER task 
#    user cannot this it in the front end.
#   function: to find the display size for the overlaying region

# programmer: sjchan 
#          created: 30apr98
#

procedure _ddispsize(img, offfl, pscale)
 
string  img     {"", prompt="Input image", mode="ql"}
string  offfl   {"offsetfile", prompt="Input offset file in arcsec", mode="ql"}
real    pscale  {0.32, prompt="input the effective pixelscale", mode="ql"}
string  fdisp  {"", prompt="Output string of input image"}
int     xdd1   {1, prompt="Display size of the input image (xmin)"}
int     ydd1   {1, prompt="Display size of the input image (ymin)"}
int    xdd2   {1024, prompt="Display size of the input image (xmax)"}
int    ydd2   {1024, prompt="Display size of the input image (ymax)"}

struct *flist1

begin

          string img1              #i input image
          string offfl1            #i input offset file
          real pscale1              #i pixelsize
          int  ncount1              #i total number of dithering positions
          string fdisp1            #i output string of input image
          real xoff1               #i xoffset in arcsec
          real yoff1               #i yoffset in arcsec
          int  xdd11               #o display xsize of input image (xmin)
          int  ydd11               #o display ysize of input image (ymin)
          int  xdd21               #o display xsize of input image (xmax)
          int  ydd21               #o display ysize of input image (ymax)
          int  naxis               # the size of image
          string sx1, sy1, sx2, sy2 # display size of the refimage in string
          real  xmin, xmax     # the x-size of the mosaiced frame
          real  ymin, ymax     # the y-size of the mosaiced frame
          int   ic             # the dummy counter
          string sec           # section of the input image 

     # Get the reset of the parameters

          img1    = img
          offfl1  = offfl
          pscale1 = pscale
          
          xmax = -9999.0; xmin = 9999.0
          ymax = -9999.0; ymin = 9999.0

          ic = 0
          flist = ""; flist = offfl1  #input approximate offset file(in asec)
          while (fscan(flist, xoff1, yoff1) != EOF)
            {
               ic += 1
               xmax = max(xoff1, xmax)
               xmin = min(xoff1, xmin)
               ymax = max(yoff1, ymax)
               ymin = min(yoff1, ymin)

            } # this brace is from while block (flist, xoff1, yoff1)
           flist= "" # close the file

           xmax = xmax/pscale1 # change into pixel coordinate from asec
           xmin = xmin/pscale1
           ymax = ymax/pscale1
           ymin = ymin/pscale1

        # Change the offset information in pixel and find out the overlaying
        # region in reference frame

                  imgets(img1, param ="i_naxis1")
                  naxis = int(imgets.value) 

		print("xmin, xmax: "//xmin//", "//xmax)
		print("ymin, ymax: "//ymin//", "//ymax)

                 xdd11 = int(xmax)+1;       xdd21 = naxis-int(abs(xmin))
                 ydd11 = int(ymax)+1;       ydd21 = naxis-int(abs(ymin))

                 sx1 = str(xdd11); sy1 = str(ydd11)
                 sx2 = str(xdd21); sy2 = str(ydd21)
                 sec = "["//sx1//":"//sx2//","//sy1//":"//sy2//"]"

                  fdisp = img1//sec
                  xdd1 = xdd11;    xdd2 = xdd21
                  ydd1 = ydd11;    ydd2 = ydd21                


end

